package haushalt.auswertung.planung;

import java.awt.Font;

import haushalt.auswertung.AbstractBlockAuswertung;
import haushalt.auswertung.bloecke.LeererBlock;
import haushalt.auswertung.bloecke.TabellenBlock;
import haushalt.auswertung.bloecke.TextBlock;
import haushalt.daten.Datenbasis;
import haushalt.daten.zeitraum.AbstractZeitraum;
import haushalt.daten.zeitraum.Jahr;
import haushalt.gui.Haushalt;
import haushalt.gui.generischerdialog.AbstractGDPane;
import haushalt.gui.generischerdialog.ZeitraumGDP;

public class BAPlanung extends AbstractBlockAuswertung {

  private static final long serialVersionUID = 1L;
  public static final String ueberschrift = "Planung";
  
  public BAPlanung(Haushalt haushalt, Datenbasis db, String name) {
    super(haushalt, db, name);
    AbstractGDPane[] panes = new AbstractGDPane[2];
    panes[0] = new ZeitraumGDP("Zeitraum:", new Jahr(2006));
    panes[1] = new PlanungGDP("Planung:", new Planung(db));
    erzeugeEigenschaften(haushalt.getFrame(), ueberschrift, panes);
  }

  protected String berechneAuswertung(Object[] werte) {
    AbstractZeitraum zeitraum = (AbstractZeitraum) werte[0];
    Planung planung = (Planung) werte[1];
    planung.setZeitraum(zeitraum);
    tabelle = planung.getVergleich();

    // Vorhandene Blcke lschen und neu berechnete einfgen
    String titel = "Planung ("+zeitraum+")";
    loescheBloecke();
    TextBlock block1 = new TextBlock(titel);
    block1.setFont(new Font(haushalt.getFontname(), Font.BOLD, haushalt.getFontgroesse()+6));
    addDokumentenBlock(block1);
    addDokumentenBlock(new LeererBlock(1));
    TabellenBlock block2 = new TabellenBlock(tabelle);
    block2.setFont(new Font(haushalt.getFontname(), Font.PLAIN, haushalt.getFontgroesse()));
    final int[] attribute = {TabellenBlock.LINKS, TabellenBlock.RECHTS, TabellenBlock.RECHTS, TabellenBlock.RECHTS};
    block2.setAusrichtung(attribute);
    addDokumentenBlock(block2);
    addDokumentenBlock(new LeererBlock(1));
    TextBlock block3 = new TextBlock(planung.getTextHochrechnen());
    block3.setFont(new Font(haushalt.getFontname(), Font.PLAIN, haushalt.getFontgroesse()-2));
    addDokumentenBlock(block3);
    return titel;
  }

}
